<template>
  <transition name="modal-fade">
    <div class="modal-backdrop">
      <div
        class="modal"
        role="dialog"
        aria-labelledby="modalTitle"
        aria-describedby="modalDescription"
      >
        <header class="modal-header">
          <slot name="header">
            This is the default Header!
          </slot>
          <button type="button" class="btn-close" @click="close">
            x
          </button>
        </header>
        <section class="modal-body">
          <slot name="body">
            I'm the default Body!
          </slot>
        </section>
        <footer class="modal-footer">
          <slot name="footer">
            I'm the default Footer!
          </slot>
          <button type="button" class="btn-green" @click="close">
            Close me!
          </button>
        </footer>
      </div>
    </div>
  </transition>
</template>

<script>
export default {
  name: 'Modal',

  methods: {
    close() {
      this.$emit('close')
    }
  }
}
</script>

<style>
.modal-backdrop {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: rgba(0, 0, 0, 0.25);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  position: absolute;
  left: calc(25vw + (var(--width-sidebar) / 2));
  height: 60vh;
  width: 50vw;
  box-shadow: 2px 2px 20px 1px;
  overflow: auto;
  display: flex;
  flex-direction: column;
  border-radius: var(--border-radius);
  color: var(--text-primary);
  background: var(--bg-primary);
}

.modal-header,
.modal-footer {
  padding: 15px;
  display: flex;
}

.modal-header {
  border-bottom: 1px solid #eeeeee;
  color: #4aae9b;
  justify-content: space-between;
}

.modal-header-content {
  text-align: center;
  font-size: 20pt;
}

.modal-footer {
  border-top: 1px solid #eeeeee;
  justify-content: space-between;
}

.modal-body {
  position: relative;
  padding: 20px 10px;
}

.btn-close {
  position: relative;
  z-index: 5;
  font-size: 1.5rem;
  padding-bottom: 0.2rem;
  height: 3rem;
  width: 3rem;
  cursor: pointer;
  color: var(--text-primary);
  background: var(--bg-secondary);
  border-radius: 50%;
}

.btn-close:hover {
  color: var(--accent-light);
}

.modal-fade-enter,
.modal-fade-leave-active {
  opacity: 0;
}

.modal-fade-enter-active,
.modal-fade-leave-active {
  transition: opacity 0.5s ease;
}
</style>
